<%
'
'  These functions are translated from Bob Denny's JScript version
'
  Function endResponse() 
		Response.Write("<br>----<br>")
		Response.End()
	End Function
    
	Function getFormText(fld) 
	  Dim fstr
		fstr = Request.Form(fld)
    fstr = Trim(fstr)
		If(fstr = "") Then
			Response.Write("[lba warning]" & fld & " is empty.")
			endResponse()
		End If
		getFormText = fstr
	End Function
        
	Function getFormDeci(fld) 
    Dim fstr, v
		fstr = getFormText(fld)
		v = CInt(fstr)
		If(not isNumeric(v)) Then
			Response.Write("[lba warning]" & fld & " [" & fstr & "] is not valid.")
			endResponse()
		End If
		getFormDeci = v
	End function
 
 Function Search (targetString)
  Dim rs
  Set rs = New RegExp
  With rs
    .Pattern = "^[-+]?[0-9]*\.?[0-9]+"
    .Global = False
    .IgnoreCase = False
  End With
  Search = rs.Test(targetString)
  End Function
 
Function Match (targetString, outString)
  Dim re, colMatch, objMatch,  m
  Set re = New RegExp
  With re
    .Pattern = "[-+]?[0-9]*\.?[0-9]+"
    .Global = True
    .IgnoreCase = True
  End With
  m = 0
  Set colMatch = re.Execute(targetString)
  For each objMatch in colMatch
     ReDim Preserve outString(m)
     outString(m) = objMatch.Value
     m = m + 1
  Next
  Match = true
End Function

	Function getFormSexa(fld) 
	  Dim fstr, mats(), val, i, token
		fstr = getFormText(fld)
    If (Not Search(fstr)) Then   	' Must begin with number
			Response.Write("[lba warning]Value must begin with number: " & fstr)
			endResponse()
		End If
     token = Match(fstr, mats)		
		If(mats(0) = "") Then   	' Must contain at least one number
			Response.Write("[lba warning]Not a decimal or sexagesimal number: " & fstr)
			endResponse()
		End If
    
		If(UBound(mats) > 3) Then	' Max of three numbers
			Response.Write("[lba warning]More than 3 numeric groups in sexagesimal: " & fstr)
			endResponse()
		End If
   
		val = 0.0		' Convert per sexagesimal
    For i = UBound(mats) To 0 Step -1
    			val = (val / 60.0) + Abs(CDbl(mats(i)))
		Next
    If(Left(mats(0), 1) = "-") Then val = -val     ' If neg, fix up sign
		getFormSexa = val
	End Function

	'
	' Main script
	'
    Dim targetFOV, targetScale, RA, Dec, sz, i, j, star, stars, starCount
    Dim catName(11), catPath(11)
    Dim positionx(), positiony(), magn()
	  Dim xx,yy,mm,idd, kk
    Dim ma, mb, mc, k

		targetFOV = 30  '  arcmin
		targetScale = 6  '  6 arcsec per pixel
		sz = 299  '   300x300 image at 6" per pixel is a 30 arcmin FOV [0..299,0..299]
		
       catName(0) = " GSC (uncorrected)"
       catName(1) = " USNO SA2.0 (not recommended)"
       catName(2) = " "
       catName(3) = " GSC 1.1"
       catName(4) = " Tycho-2"
       catName(5) = " USNO A2.0"
       catName(6) = "~UCAC2"
       catName(7) = " USNO B1.0 (local disk)"
       catName(8) = " USNO B1.0 (Internet)"
       catName(9) = " NOMAD (Internet)"
       catName(10) = "~UCAC3"
       catName(11) = "~UCAC4"
'
'  Each user needs to put in the correct locations of catalogs on their computer drives.
'       
       catPath(2) = "unavailable"
       catPath(3) = "C:\Catalogs\GSC-11"
       catPath(4) = "C:\Catalogs\TYCHO-2"
       catPath(5) = "C:\Catalogs\USNO-A2.0"
       catPath(6) = "C:\Catalogs\UCAC2"
       catPath(7) = "unavailable"
       catPath(8) = "not needed"
       catPath(9) = "not needed"
       catPath(10) = "C:\Catalogs\UCAC3"
       catPath(11) = "C:\Catalogs\UCAC4\"
	
    ReDim imArray(sz, sz)			' Creates a 2-D temporary "image" array needed for the "plate" object
    For i = 0 To sz
        For j = 0 To sz
            imArray(i,j) = CLng(0)
        Next
    Next
	'
	' Attach PinPoint and analyze
	'
  Set plate = CreateObject("PinPoint.Plate")
	plate.ImageArray =  imArray
	plate.ArcsecPerPixelHoriz = targetScale
	plate.ArcsecPerPixelVert = targetScale
	plate.CatalogMaximumMagnitude = 16
	plate.CatalogExpansion = 0.0
	plate.ExposureStartTime =  Now  '  Arbitrary date - doesn't matter.
	plate.RollAngle = 0
	plate.Equinox = 2000 
	plate.ProjectionType = 1

	plate.RightAscension =  getFormSexa("RA")    '    Reads the RA field on the form
	plate.Declination =  getFormSexa("Dec")         '    Reads the Dec field on the form

	plate.Catalog =  getFormDeci("Catlog")   ' or perhaps   Util.Prefs.ReferenceCatalogType
	plate.CatalogPath = catPath(plate.Catalog)  ' or perhaps   Util.Prefs.ReferenceCatalogPath 
		
  Response.Write(catName(plate.Catalog) & " catalog image is 30' x 30'" & _
					" and centered at RA: " & Util.Hours_HMS(plate.RightAscension) & _
					", Dec: " & Util.Degrees_DMS(plate.Declination, "&deg; "))
        
  plate.FindCatalogStars()    '    Gather the collection of stars from the catalog

	Set stars = plate.CatalogStars
    If (stars.Count = 0) Then
        starCount = 0
    Else 
        starCount = stars.Count
        Response.Write("<br>Found " & starCount & " stars in the catalog at " & _ 
			  plate.CatalogMaximumMagnitude & "th magnitude or brighter.")
        Response.Write ("<br>~~(5' x 5' grid)~~")
		
        kk = 0  
	      For Each star In stars
            ReDim Preserve positionx(kk)
            ReDim Preserve positiony(kk)
            ReDim Preserve magn(kk)
            positionx(kk)  = CInt(star.X)
            positiony(kk) = CInt(star.Y)
            magn(kk) = CInt(10*(star.Magnitude))/10.0   '  magnitudes to 1/10th 
            idd = star.Identification
'           Response.Write("<br>" & idd & ":&nbsp;&nbsp;&nbsp; X = " & positionx(kk) & ", Y = " & positiony(kk) & ", Mag = " & magn(kk))  '  This will list each star by ID, x, y, and mag
            kk = kk + 1
        Next
	  End If 
        Response.Write ("<div class='SVGgraph' style='background-color:#000020; border:solid 4px grey' options='width:400,height:400,scales:[0,300,0,300]'>")
        Response.Write ("SVG.locked = true;")

    If (starCount <> 0)  Then    '    Draw the grid, the annotation and the stars
        k = 0
        Response.Write ("grid({dx:50,dy:50,stroke:'darkred',strokeopacity:0.95,strokedasharray:3.33});")
		    Response.Write ("path([[145,150],[155,150]],{stroke:'darkred'});")   ' The cross-hair in the middle
		    Response.Write ("path([[150,145],[150,155]],{stroke:'darkred'});")
        Response.Write ("text([150,290],'N',{fontsize:14,fontfill:'yellow'});")
        Response.Write ("text([10,149],'E',{fontsize:14,fontfill:'yellow'});")
        Do 
         ma = 300 - positionx(k)
         mb = positiony(k)
		     mc = 16 - magn(k)
		     mc = mc*0.625  ' scale to the range [0..5]
		     If  ( mc <= 0 ) Then mc = 0.5   '  stars 16th mag and fainter are size 0.5
		     If ( mc >= 5 ) Then mc = 5   'stars 8th mag and brighter are size 5
         mc = mc*300/400    '  rescale to match the graphic scale
  	     Response.Write ("circle([" & ma & "," & mb &"]," & mc & ",{stroke:'none',fill:'#ddd', fillopacity:0.75});")
		     k = k + 1
      Loop While  k < starCount
    Else     '    There's no stars, so say so
	       Response.Write ("text([150,150],'No stars in the catalog at this location.',{fontsize:24,fontfill:'yellow'});")
    End If
        Response.Write ("</div>")

    If starCount <> 0 Then      ' Draw the legend
      Response.Write ("<span class='SVGgraph' style='background-color:none border:none' options='width:400,height:40,scales:[0,400,0,40]'>")
        Response.Write ("circle([40,25], 5.0,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([80,25], 4.438,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([120,25], 3.875,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([160,25], 3.313,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([200,25], 2.750,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([240,25], 2.188,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([280,25], 1.625,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([320,25], 1.063,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("circle([360,25], 0.5,{stroke:'none',fill:'#ddd', fillopacity:0.75});")
        Response.Write ("text([40,10],'8&#8593;',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([80,10],'9',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([120,10],'10',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([160,10],'11',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([200,10],'12',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([240,10],'13',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([280,10],'14',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([320,10],'15',{fontsize:12,fontfill:'#880'});")
        Response.Write ("text([360,10],'16',{fontsize:12,fontfill:'#880'});")    '  &#8595; = down-arrow
      Response.Write ("</span>")
        Response.Write ("<br>")
    End If
%>